//+-------------------------------------------------------------------+
//|                                            Bollinger Bands %b.mq4 |
//|                           Original indicator by Alejandro Galindo |
//|                  Modified and Corrected by Linuxser for forex TSD |
//|                                                                   |
//| John Bollinger original formula is:                               |
//| (Last - Lower BB)/(Upper BB - Lower BB)                           |
//+-------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Goldenrod
#property indicator_color2 Goldenrod
#property indicator_color3 Goldenrod
#property indicator_color4 Goldenrod

//---- input parameters
extern int RSIPeriod=14;
extern int BBPeriod=20;
extern int StdDeviation=2;
//---- buffers
double RSIBuffer[];
double BLGBuffer[];
double BLGBuffer1[];
double BLGBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line

   SetIndexBuffer(0,RSIBuffer);  
   SetIndexBuffer(1,BLGBuffer);   
   SetIndexBuffer(2,BLGBuffer1);
   SetIndexBuffer(3,BLGBuffer2);
   
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexStyle(3,DRAW_NONE);
   
   SetIndexLabel(0,"RSI");
   SetIndexLabel(1,"RSI");
   SetIndexLabel(2,"Upper %BB RSI");
   SetIndexLabel(3,"Lower %BB RSI");
//---- name for DataWindow and indicator subwindow label
   short_name="%b("+BBPeriod+","+StdDeviation+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,BBPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=BBPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=BBPeriod;i++) BLGBuffer[Bars-i]=0.0;
//----
   i=Bars-BBPeriod-1;
   if(counted_bars>=BBPeriod) i=Bars-counted_bars-1;
   while(i>=0)
     {
      RSIBuffer[i]=iRSI(NULL,0,RSIPeriod,PRICE_CLOSE,i);
      BLGBuffer1[i]=iBandsOnArray(RSIBuffer,Bars,BBPeriod,StdDeviation,0,1,i);
      BLGBuffer2[i]=iBandsOnArray(RSIBuffer,Bars,BBPeriod,StdDeviation,0,2,i);

      if(RSIBuffer[i]!=0) 
      BLGBuffer[i]=(RSIBuffer[i] - BLGBuffer1[i]) / (BLGBuffer1[i] - BLGBuffer2[i]);
      i--;
     }
   return(0);
  }
//+------------------------------------------------------------------+