//+------------------------------------------------------------------+
//|                                                    RSI bands.mq4 |
//|                                                           mladen |
//|                                                                  |
//| RSI bands developed by Franois Bertrand                         |
//| source : TASC april 2008                                         |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 OrangeRed
#property indicator_color3 LimeGreen
#property indicator_color4 Red
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT

//
//
//
//
//

extern string _              = "Parameters";
extern int    RSI.Period     = 14;
extern int    RSI.Price      = PRICE_CLOSE;
extern double RSI.Dampening  = 0.5;
extern int    RSI.OverBought = 70;
extern int    RSI.OverSold   = 30;

//
//
//
//
//

double bufferUp[];
double bufferDo[];
double bufferDUp[];
double bufferDDo[];
double pu[];
double pd[];
double nu[];
double nd[];
bool   calculating=false;
string indicatorFileName;



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   indicatorFileName = WindowExpertName();
   calculating       = (_=="dampening");
   IndicatorBuffers(8);
      SetIndexBuffer(0,bufferDUp); SetIndexLabel(0,"Dumpening over bought");
      SetIndexBuffer(1,bufferDDo); SetIndexLabel(0,"Dumpening over sold");
      SetIndexBuffer(2,bufferUp);  SetIndexLabel(0,"Over bought");
      SetIndexBuffer(3,bufferDo);  SetIndexLabel(0,"Over sold");
      SetIndexBuffer(4,pu);
      SetIndexBuffer(5,pd);
      SetIndexBuffer(6,nu);
      SetIndexBuffer(7,nd);
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //
     
   for(i=limit; i>=0; i--)
   {
      if (calculating)
         {
            bufferUp[i] = rsiBand(bufferUp[i+1],pu,nu,RSI.OverBought,i,RSI.Dampening);
            bufferDo[i] = rsiBand(bufferDo[i+1],pd,nd,RSI.OverSold  ,i,RSI.Dampening);
         }         
      else
         {
            bufferUp[i] = rsiBand(bufferUp[i+1],pu,nu,RSI.OverBought,i,0);
            bufferDo[i] = rsiBand(bufferDo[i+1],pd,nd,RSI.OverSold  ,i,0);
            if (RSI.Dampening !=0)
            {
               bufferDUp[i] = iCustom(NULL,0,indicatorFileName,"dampening",RSI.Period,RSI.Price,RSI.Dampening,RSI.OverBought,RSI.OverSold,2,i);
               bufferDDo[i] = iCustom(NULL,0,indicatorFileName,"dampening",RSI.Period,RSI.Price,RSI.Dampening,RSI.OverBought,RSI.OverSold,3,i);
            }
         }         
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double rsiBand(double prev, double& pa[], double& na[], double targetLevel,int i, double dampening)
{
   double pprice = iMA(NULL,0,1,0,MODE_SMA,RSI.Price,i+1);
   double cprice = iMA(NULL,0,1,0,MODE_SMA,RSI.Price,i);
   double diff   = cprice-pprice;
   double match  = 0.00;
   double w      = 0.00;
   double s      = 0.00;
   double p      = pa[i+1];
   double n      = na[i+1];
 
   //
   //
   //
   //
   //
   
      if (diff > 0) w =  diff;
      if (diff < 0) s = -diff;
      if (prev > pprice)
            match = pprice + p - p*RSI.Period - ((n*RSI.Period)-n)*targetLevel/(targetLevel-100.00);
      else  match = pprice - n - p + n*RSI.Period + p*RSI.Period + (100.00*p)/targetLevel - (100.00*p*RSI.Period)/targetLevel;
      if (dampening != 0)
            if      ((match - cprice) > ( dampening/100 * cprice)) match = cprice * ( 1 + dampening/100 );
            else if ((match - cprice) < (-dampening/100 * cprice)) match = cprice * ( 1 - dampening/100 ) ;

      //
      //
      //
      //
      //
      
      pa[i] = ((RSI.Period-1)*p+w)/RSI.Period;
      na[i] = ((RSI.Period-1)*n+s)/RSI.Period;

   //
   //
   //
   //
   //
   
   return(match);
}