//+------------------------------------------------------------------+
//|                                                        RSI_2.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window

#property indicator_buffers 4
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_color3 Lime
#property indicator_color4 Gold
//---- input parameters
extern int raz_Array=30;
extern int RSIPeriod=14;
extern int t3_period=8;
extern double b=0.7;
extern int ExtDepth=21;
extern int ExtDeviation=13;
extern int ExtBackstep=34;

                 
//---- buffers
double t3_RSIBuffer[];
double ExtMapBuffer[];
double ExtMapBuffer2[];
double max[], min[];
double e1, e2, e3, e4, e5, e6, c1, c2, c3, c4, n, w1, w2, b2, b3, i_WPR;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(5);
   SetIndexBuffer(4,ExtMapBuffer2);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexBuffer(0,t3_RSIBuffer);
   SetIndexStyle(1,DRAW_SECTION,2);
   SetIndexBuffer(1,ExtMapBuffer);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,max);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,min);
//---- name for DataWindow and indicator subwindow label
   short_name="RSI("+RSIPeriod+", "+raz_Array+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,RSIPeriod+t3_period);
   SetIndexDrawBegin(1,RSIPeriod+t3_period);

   b2=b*b;
   b3=b2*b;
   c1=-b3;
   c2=(3*(b2+b3));
   c3=-3*(2*b2+b+b3);
   c4=(1+3*b+b3+3*b2);
   n=t3_period;

   if (n<1) n=1;
   n = 1 + 0.5*(n-1);
   w1 = 2 / (n + 1);
   w2 = 1 - w1;
//----
   return(0);
  }
int deinit()
{

}  
//+------------------------------------------------------------------+
//| Relative Strength Index                                          |
//+------------------------------------------------------------------+
int start()
  {
   int    i,counted_bars=IndicatorCounted();
//----   
   int    shift, back,lasthighpos,lastlowpos,index;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;
//----

//---- initial zero

   for(i=Bars-1; i>=0; i--)
    {
    i_WPR=iRSI(NULL,0,RSIPeriod,PRICE_CLOSE,i);
     e1 = w1*i_WPR + w2*e1;
     e2 = w1*e1 + w2*e2;
     e3 = w1*e2 + w2*e3;
     e4 = w1*e3 + w2*e4;
     e5 = w1*e4 + w2*e5;
     e6 = w1*e5 + w2*e6;

     t3_RSIBuffer[i] = c1*e6 + c2*e5 + c3*e4 + c4*e3;
      max[i]=t3_RSIBuffer[ArrayMaximum(t3_RSIBuffer,raz_Array,i)];
      min[i]=t3_RSIBuffer[ArrayMinimum(t3_RSIBuffer,raz_Array,i)];
    }
   for(shift=Bars-1; shift>=0; shift--)
     {
      int n, sn, r, result;
      bool ft=true;
      for(n=1; n<ExtDepth; n++)
       {
        sn=shift+n;
        if(ft)
         {
          if(t3_RSIBuffer[shift]<t3_RSIBuffer[sn]) result=shift;
          else result=sn;
          r=result;
          ft=false;
         } 
        else
         {
          if(t3_RSIBuffer[r]<t3_RSIBuffer[sn]) result=r;
          else result=sn;
          r=result;
         }
       }    
      index=r;
      val=t3_RSIBuffer[index];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((t3_RSIBuffer[shift]-val)>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer[shift+back];
               if((res!=0)&&(res>val)) ExtMapBuffer[shift+back]=0.0; 
              }
           }
        } 
      ExtMapBuffer[shift]=val;
      //--- high
      ft=true;
      for(n=1; n<ExtDepth; n++)
       {
        sn=shift+n;
        if(ft)
         {
          if(t3_RSIBuffer[shift]>t3_RSIBuffer[sn]) result=shift;
          else result=sn;
          r=result;
          ft=false;
         }
        else
         {
          if(t3_RSIBuffer[r]>t3_RSIBuffer[sn]) result=r;
          else result=sn;
          r=result;
         }
       }  
      index=r;
      val=t3_RSIBuffer[index];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-t3_RSIBuffer[shift])>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer2[shift+back];
               if((res!=0)&&(res<val)) ExtMapBuffer2[shift+back]=0.0; 
              } 
           }
        }
      ExtMapBuffer2[shift]=val;
     }
//---- final cutting 
   lasthigh=-1; lasthighpos=-1;
   lastlow=-1;  lastlowpos=-1;

   for(shift=Bars-ExtDepth; shift>=0; shift--)
     {
      curlow=ExtMapBuffer[shift];
      curhigh=ExtMapBuffer2[shift];
      if((curlow==0)&&(curhigh==0)) continue;
      //---
      if(curhigh!=0)
        {
         if(lasthigh>0) 
           {
            if(lasthigh<curhigh) ExtMapBuffer2[lasthighpos]=0;
            else ExtMapBuffer2[shift]=0;
           }
         //---
         if(lasthigh<curhigh || lasthigh<0)
           {
            lasthigh=curhigh;
            lasthighpos=shift;
           }
         lastlow=-1;
        }
      //----
      if(curlow!=0)
        {
         if(lastlow>0)
           {
            if(lastlow>curlow) ExtMapBuffer[lastlowpos]=0;
            else ExtMapBuffer[shift]=0;
           }
         //---
         if((curlow<lastlow)||(lastlow<0))
           {
            lastlow=curlow;
            lastlowpos=shift;
           } 
         lasthigh=-1;
        }
     }
  
   for(shift=Bars-1; shift>=0; shift--)
     {
      if(shift>=Bars-ExtDepth) ExtMapBuffer[shift]=0.0;
      else
        {
         res=ExtMapBuffer2[shift];
         if(res!=0.0) ExtMapBuffer[shift]=res;
        }
     } 
      
//----
   return(0);
  }
//+------------------------------------------------------------------+